Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2232)
@@ -3626,5 +4327,5 @@
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             nzb_s_inner, logc_u_r,            &
+                                             logc_u_r,                         &
                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
                                              'r', 's' ) 
@@ -3636,29 +4337,28 @@
              IF ( passive_scalar )  THEN
                 CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
+                                          r1yo, r2yo, r1zo, r2zo,              &
                                           logc_u_r, logc_ratio_u_r,            &
                                           nzt_topo_nestbc_r, 'r', 's' )
+
              ENDIF
 
              IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
-
-                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
-                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
-                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
-                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'r', 'e' )
+                CALL pmci_extrap_ifoutflow_lr( u, 'r', 'u' )
+                CALL pmci_extrap_ifoutflow_lr( v, 'r', 'v' )
+                CALL pmci_extrap_ifoutflow_lr( w, 'r', 'w' )
+                CALL pmci_extrap_ifoutflow_lr( e, 'r', 'e' )
 
                 IF ( .NOT. neutral )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'r', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( pt, 'r', 's' )
                 ENDIF
 
                 IF ( humidity )  THEN
-
-                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'r', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( q, 'r', 's' )
 
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_lr( qc, nzb_s_inner, 'r', 's' )
-                      CALL pmci_extrap_ifoutflow_lr( qr, nzb_s_inner, 'r', 's' )
-!                      CALL pmci_extrap_ifoutflow_lr( nc, nzb_s_inner, 'r', 's' )  
-                      CALL pmci_extrap_ifoutflow_lr( nr, nzb_s_inner, 'r', 's' )
+!                       CALL pmci_extrap_ifoutflow_lr( qc, 'r', 's' )
+                      CALL pmci_extrap_ifoutflow_lr( qr, 'r', 's' )
+!                      CALL pmci_extrap_ifoutflow_lr( nc, 'r', 's' )  
+                      CALL pmci_extrap_ifoutflow_lr( nr, 'r', 's' )
                    ENDIF
 
@@ -3666,5 +4366,5 @@
 
                 IF ( passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( s, nzb_s_inner, 'r', 's' )
+                   CALL pmci_extrap_ifoutflow_lr( s, 'r', 's' )
                 ENDIF
              ENDIF
@@ -3675,36 +4375,32 @@
    !--    South border pe
           IF ( nest_bound_s )  THEN
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,    &
-                                       logc_u_s, logc_ratio_u_s,               &
+             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_s, logc_ratio_u_s,                &
                                        nzt_topo_nestbc_s, 's', 'u' )
-
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
-                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,    &
-                                       logc_v_s, logc_ratio_v_s,               &
+             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo,                  &
+                                       logc_v_s, logc_ratio_v_s,                &
                                        nzt_topo_nestbc_s, 's', 'v' )
-
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,    &
-                                       logc_w_s, logc_ratio_w_s,               &
+             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw,                  &
+                                       logc_w_s, logc_ratio_w_s,                &
                                        nzt_topo_nestbc_s, 's','w' )
-
-             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_s, logc_ratio_u_s,               &
+             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_s, logc_ratio_u_s,                &
                                        nzt_topo_nestbc_s, 's', 'e' )
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_s, logc_ratio_u_s,            &
+                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_s, logc_ratio_u_s,             &
                                           nzt_topo_nestbc_s, 's', 's' )
              ENDIF
 
              IF ( humidity )  THEN
-
-                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo,r2yo, r1zo, r2zo, nzb_s_inner,  &
-                                          logc_u_s, logc_ratio_u_s,            &
+                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,    &
+                                          r1yo,r2yo, r1zo, r2zo,                &
+                                          logc_u_s, logc_ratio_u_s,             &
                                           nzt_topo_nestbc_s, 's', 's' )
 
@@ -3713,5 +4409,5 @@
 !                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-!                                              nzb_s_inner, logc_u_s,            &
+!                                              logc_u_s,                         &
 !                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
 !                                              's', 's' )
@@ -3719,5 +4415,5 @@
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-                                             nzb_s_inner, logc_u_s,            &
+                                             logc_u_s,                         &
                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
                                              's', 's' )
@@ -3725,5 +4421,5 @@
 !                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-!                                              nzb_s_inner, logc_u_s,            &
+!                                              logc_u_s,                         &
 !                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
 !                                              's', 's' )
@@ -3731,5 +4427,5 @@
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-                                             nzb_s_inner, logc_u_s,            &
+                                             logc_u_s,                         &
                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
                                              's', 's' )
@@ -3740,30 +4436,28 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo,r2yo, r1zo, r2zo, nzb_s_inner,  &
-                                          logc_u_s, logc_ratio_u_s,            &
+                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo,r2yo, r1zo, r2zo,                &
+                                          logc_u_s, logc_ratio_u_s,             &
                                           nzt_topo_nestbc_s, 's', 's' )
              ENDIF
 
              IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
-
-                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
-                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 's', 'v' )
-                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 's', 'w' )
-                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 's', 'e' )
+                CALL pmci_extrap_ifoutflow_sn( u, 's', 'u' )
+                CALL pmci_extrap_ifoutflow_sn( v, 's', 'v' )
+                CALL pmci_extrap_ifoutflow_sn( w, 's', 'w' )
+                CALL pmci_extrap_ifoutflow_sn( e, 's', 'e' )
 
                 IF ( .NOT. neutral )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 's', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( pt, 's', 's' )
                 ENDIF
 
                 IF ( humidity )  THEN
-
-                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 's', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( q,  's', 's' )
 
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_sn( qc, nzb_s_inner, 's', 's' ) 
-                      CALL pmci_extrap_ifoutflow_sn( qr, nzb_s_inner, 's', 's' )      
-!                       CALL pmci_extrap_ifoutflow_sn( nc, nzb_s_inner, 's', 's' ) 
-                      CALL pmci_extrap_ifoutflow_sn( nr, nzb_s_inner, 's', 's' ) 
+!                       CALL pmci_extrap_ifoutflow_sn( qc, 's', 's' ) 
+                      CALL pmci_extrap_ifoutflow_sn( qr, 's', 's' )      
+!                       CALL pmci_extrap_ifoutflow_sn( nc, 's', 's' ) 
+                      CALL pmci_extrap_ifoutflow_sn( nr, 's', 's' ) 
 
                    ENDIF
@@ -3772,5 +4466,5 @@
 
                 IF ( passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( s, nzb_s_inner, 's', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( s,  's', 's' )
                 ENDIF
 
@@ -3782,34 +4476,35 @@
    !--    North border pe
           IF ( nest_bound_n )  THEN
-
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_u_inner,    &
-                                       logc_u_n, logc_ratio_u_n,               &
+             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_n, logc_ratio_u_n,                &
                                        nzt_topo_nestbc_n, 'n', 'u' )
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
-                                       r1yv, r2yv, r1zo, r2zo, nzb_v_inner,    &
-                                       logc_v_n, logc_ratio_v_n,               & 
+
+             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo,                  &
+                                       logc_v_n, logc_ratio_v_n,                & 
                                        nzt_topo_nestbc_n, 'n', 'v' )
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zw, r2zw, nzb_w_inner,    &
-                                       logc_w_n, logc_ratio_w_n,               &
+
+             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw,                  &
+                                       logc_w_n, logc_ratio_w_n,                &
                                        nzt_topo_nestbc_n, 'n', 'w' )
-             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zo, r2zo, nzb_s_inner,    &
-                                       logc_u_n, logc_ratio_u_n,               &
+
+             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_n, logc_ratio_u_n,                &
                                        nzt_topo_nestbc_n, 'n', 'e' )
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_n, logc_ratio_u_n,            &
+                CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_n, logc_ratio_u_n,             &
                                           nzt_topo_nestbc_n, 'n', 's' )
              ENDIF
 
              IF ( humidity )  THEN
-
-                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_n, logc_ratio_u_n,            &
+                CALL pmci_interp_tril_sn( q, q_c, ico, jco, kco, r1xo, r2xo,    &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_n, logc_ratio_u_n,             &
                                           nzt_topo_nestbc_n, 'n', 's' )
 
@@ -3818,5 +4513,5 @@
 !                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              nzb_s_inner, logc_u_n,            &
+!                                              logc_u_n,                         &
 !                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
 !                                              'n', 's' )
@@ -3824,5 +4519,5 @@
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             nzb_s_inner, logc_u_n,            &
+                                             logc_u_n,                         &
                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
                                              'n', 's' )
@@ -3830,5 +4525,5 @@
 !                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
 !                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              nzb_s_inner, logc_u_n,            &
+!                                              logc_u_n,                         &
 !                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
 !                                              'n', 's' )
@@ -3836,5 +4531,5 @@
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             nzb_s_inner, logc_u_n,            &
+                                             logc_u_n,                         &
                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
                                              'n', 's' )
@@ -3845,30 +4540,28 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo, r2yo, r1zo, r2zo, nzb_s_inner, &
-                                          logc_u_n, logc_ratio_u_n,            &
+                CALL pmci_interp_tril_sn( s, sc, ico, jco, kco, r1xo, r2xo,     &
+                                          r1yo, r2yo, r1zo, r2zo,               &
+                                          logc_u_n, logc_ratio_u_n,             &
                                           nzt_topo_nestbc_n, 'n', 's' )
              ENDIF
 
              IF ( TRIM( nesting_mode ) == 'one-way' )  THEN
-
-                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
-                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 'n', 'v' )
-                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 'n', 'w' )
-                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 'n', 'e' )
+                CALL pmci_extrap_ifoutflow_sn( u, 'n', 'u' )
+                CALL pmci_extrap_ifoutflow_sn( v, 'n', 'v' )
+                CALL pmci_extrap_ifoutflow_sn( w, 'n', 'w' )
+                CALL pmci_extrap_ifoutflow_sn( e, 'n', 'e' )
 
                 IF ( .NOT. neutral )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 'n', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( pt, 'n', 's' )
                 ENDIF
 
                 IF ( humidity )  THEN
-
-                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( q,  'n', 's' )
 
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_sn( qc, nzb_s_inner, 'n', 's' )
-                      CALL pmci_extrap_ifoutflow_sn( qr, nzb_s_inner, 'n', 's' )
-!                       CALL pmci_extrap_ifoutflow_sn( nc, nzb_s_inner, 'n', 's' )
-                      CALL pmci_extrap_ifoutflow_sn( nr, nzb_s_inner, 'n', 's' )
+!                       CALL pmci_extrap_ifoutflow_sn( qc, 'n', 's' )
+                      CALL pmci_extrap_ifoutflow_sn( qr, 'n', 's' )
+!                       CALL pmci_extrap_ifoutflow_sn( nc, 'n', 's' )
+                      CALL pmci_extrap_ifoutflow_sn( nr, 'n', 's' )
                    ENDIF
 
@@ -3876,5 +4569,5 @@
 
                 IF ( passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( s, nzb_s_inner, 'n', 's' )
+                   CALL pmci_extrap_ifoutflow_sn( s,  'n', 's' )
                 ENDIF
 
@@ -3883,5 +4576,5 @@
           ENDIF
 
-       ENDIF       !: IF ( nesting_mode /= 'vertical' )
+       ENDIF       ! IF ( nesting_mode /= 'vertical' )
 
 !
@@ -4016,5 +4709,5 @@
 
    SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
-                                   r2z, kb, logc, logc_ratio, nzt_topo_nestbc,  &
+                                   r2z, logc, logc_ratio, nzt_topo_nestbc,      &
                                    edge, var )
 !
@@ -4040,5 +4733,4 @@
       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic     !:
       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc     !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb     !:
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !:
       INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                 &
@@ -4049,22 +4741,25 @@
       CHARACTER(LEN=1), INTENT(IN) ::  var    !:
 
-      INTEGER(iwp) ::  i       !:
-      INTEGER(iwp) ::  ib      !:
-      INTEGER(iwp) ::  ibgp    !:
-      INTEGER(iwp) ::  iw      !:
-      INTEGER(iwp) ::  j       !:
-      INTEGER(iwp) ::  jco     !:
-      INTEGER(iwp) ::  jcorr   !:
-      INTEGER(iwp) ::  jinc    !:
-      INTEGER(iwp) ::  jw      !:
-      INTEGER(iwp) ::  j1      !:
-      INTEGER(iwp) ::  k       !:
-      INTEGER(iwp) ::  kco     !:
-      INTEGER(iwp) ::  kcorr   !:
-      INTEGER(iwp) ::  k1      !:
-      INTEGER(iwp) ::  l       !:
-      INTEGER(iwp) ::  m       !:
-      INTEGER(iwp) ::  n       !:
-      INTEGER(iwp) ::  kbc     !:
+      INTEGER(iwp) ::  flag_nr  !: Number of flag array to mask topography on respective u/v/w or s grid
+      INTEGER(iwp) ::  flag_nr2 !: Number of flag array to indicate vertical index of topography top on respective u/v/w or s grid
+      INTEGER(iwp) ::  i        !:
+      INTEGER(iwp) ::  ib       !:
+      INTEGER(iwp) ::  ibgp     !:
+      INTEGER(iwp) ::  iw       !:
+      INTEGER(iwp) ::  j        !:
+      INTEGER(iwp) ::  jco      !:
+      INTEGER(iwp) ::  jcorr    !:
+      INTEGER(iwp) ::  jinc     !:
+      INTEGER(iwp) ::  jw       !:
+      INTEGER(iwp) ::  j1       !:
+      INTEGER(iwp) ::  k        !:
+      INTEGER(iwp) ::  k_wall   !: vertical index of topography top
+      INTEGER(iwp) ::  kco      !:
+      INTEGER(iwp) ::  kcorr    !:
+      INTEGER(iwp) ::  k1       !:
+      INTEGER(iwp) ::  l        !:
+      INTEGER(iwp) ::  m        !:
+      INTEGER(iwp) ::  n        !:
+      INTEGER(iwp) ::  kbc      !:
       
       REAL(wp) ::  coarse_dx   !:
@@ -4094,7 +4789,22 @@
          ib = nxr + 2
       ENDIF
+!
+!--    Determine number of flag array to be used to mask topography
+       IF ( var == 'u' )  THEN
+          flag_nr  = 1
+          flag_nr2 = 14
+       ELSEIF ( var == 'v' )  THEN
+          flag_nr  = 2
+          flag_nr2 = 16
+       ELSEIF ( var == 'w' )  THEN
+          flag_nr  = 3
+          flag_nr2 = 18
+       ELSE
+          flag_nr  = 0
+          flag_nr2 = 12
+       ENDIF
       
       DO  j = nys, nyn+1
-         DO  k = kb(j,i), nzt+1
+         DO  k = nzb, nzt+1
             l = ic(i)
             m = jc(j)
@@ -4119,5 +4829,13 @@
       IF ( var == 'u' .OR. var == 'v' )  THEN           
          DO  j = nys, nyn
-            k = kb(j,i)+1
+!
+!--         Determine vertical index of topography top at grid point (j,i)
+            k_wall = MAXLOC(                                                   &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )&
+                             ), DIM = 1                                        &
+                           ) - 1
+
+            k = k_wall+1
             IF ( ( logc(1,k,j) /= 0 )  .AND.  ( logc(2,k,j) == 0 ) )  THEN
                k1 = logc(1,k,j)
@@ -4141,5 +4859,12 @@
 !--         Solid surface only on south/north side of the node                   
             DO  j = nys, nyn
-               DO  k = kb(j,i)+1, nzt_topo_nestbc
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall+1, nzt_topo_nestbc
                   IF ( ( logc(2,k,j) /= 0 )  .AND.  ( logc(1,k,j) == 0 ) )  THEN
 !
@@ -4162,5 +4887,12 @@
          IF ( var == 'u' )  THEN
             DO  j = nys, nyn
-               k = kb(j,i) + 1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               k = k_wall + 1
                IF ( ( logc(2,k,j) /= 0 )  .AND.  ( logc(1,k,j) /= 0 ) )  THEN
                   k1   = logc(1,k,j)                 
@@ -4190,5 +4922,12 @@
          IF ( edge == 'l' )  THEN
             DO  j = nys, nyn + 1
-               DO  k = kb(j,i), nzt + 1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall, nzt + 1
                   f(k,j,i) = tkefactor_l(k,j) * f(k,j,i)
                ENDDO
@@ -4196,5 +4935,12 @@
          ELSEIF ( edge == 'r' )  THEN           
             DO  j = nys, nyn+1
-               DO  k = kb(j,i), nzt+1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall, nzt+1
                   f(k,j,i) = tkefactor_r(k,j) * f(k,j,i)
                ENDDO
@@ -4220,5 +4966,5 @@
 
    SUBROUTINE pmci_interp_tril_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z,  &
-                                   r2z, kb, logc, logc_ratio,                   &
+                                   r2z, logc, logc_ratio,                   &
                                    nzt_topo_nestbc, edge, var )
 
@@ -4245,5 +4991,4 @@
       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !:
       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !:
       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
       INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                 &
@@ -4254,4 +4999,6 @@
       CHARACTER(LEN=1), INTENT(IN) ::  var    !:
       
+      INTEGER(iwp) ::  flag_nr  !: Number of flag array to mask topography on respective u/v/w or s grid
+      INTEGER(iwp) ::  flag_nr2 !: Number of flag array to indicate vertical index of topography top on respective u/v/w or s grid
       INTEGER(iwp) ::  i       !:
       INTEGER(iwp) ::  iinc    !:
@@ -4263,4 +5010,5 @@
       INTEGER(iwp) ::  jbgp    !:
       INTEGER(iwp) ::  k       !:
+      INTEGER(iwp) ::  k_wall   !: vertical index of topography top
       INTEGER(iwp) ::  kcorr   !:
       INTEGER(iwp) ::  kco     !:
@@ -4297,6 +5045,29 @@
       ENDIF
 
+!
+!--    Determine number of flag array to be used to mask topography
+       IF ( var == 'u' )  THEN
+          flag_nr  = 1
+          flag_nr2 = 14
+       ELSEIF ( var == 'v' )  THEN
+          flag_nr  = 2
+          flag_nr2 = 16
+       ELSEIF ( var == 'w' )  THEN
+          flag_nr  = 3
+          flag_nr2 = 18
+       ELSE
+          flag_nr  = 0
+          flag_nr2 = 12
+       ENDIF
+
       DO  i = nxl, nxr+1
-         DO  k = kb(j,i), nzt+1
+!
+!--      Determine vertical index of topography top at grid point (j,i)
+         k_wall = MAXLOC(                                                      &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )&
+                             ), DIM = 1                                        &
+                           ) - 1
+         DO  k = k_wall, nzt+1
             l = ic(i)
             m = jc(j)
@@ -4321,5 +5092,13 @@
       IF ( var == 'u'  .OR.  var == 'v' )  THEN           
          DO  i = nxl, nxr
-            k = kb(j,i) + 1
+!
+!--         Determine vertical index of topography top at grid point (j,i)
+            k_wall = MAXLOC(                                                   &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )&
+                             ), DIM = 1                                        &
+                           ) - 1
+
+            k = k_wall + 1
             IF ( ( logc(1,k,i) /= 0 )  .AND.  ( logc(2,k,i) == 0 ) )  THEN
                k1 = logc(1,k,i)
@@ -4342,5 +5121,12 @@
          IF ( var == 'v' .OR. var == 'w' )  THEN
             DO  i = nxl, nxr
-               DO  k = kb(j,i), nzt_topo_nestbc
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall, nzt_topo_nestbc
 !
 !--               Solid surface only on left/right side of the node           
@@ -4365,5 +5151,12 @@
          IF ( var == 'v' )  THEN
             DO  i = nxl, nxr
-               k = kb(j,i) + 1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               k = k_wall + 1
                IF ( ( logc(2,k,i) /= 0 )  .AND.  ( logc(1,k,i) /= 0 ) )  THEN
                   k1   = logc(1,k,i)         
@@ -4393,5 +5186,12 @@
          IF ( edge == 's' )  THEN
             DO  i = nxl, nxr + 1
-               DO  k = kb(j,i), nzt+1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall, nzt+1
                   f(k,j,i) = tkefactor_s(k,i) * f(k,j,i)
                ENDDO
